#include <stdio.h>
#include <sys/stat.h>

#include "http_loop.h"

void http_loop_res_set_body_buf(http_loop_ctx *ctx, const char *body,
                                size_t body_len, bool owned) {
  ctx->res.body_type = http_response_body_buf;
  ctx->res.body = (void *)body;
  ctx->res.body_len = body_len;
  ctx->res.owns_body = owned;
}

void http_loop_res_set_body_file(http_loop_ctx *ctx, const char *filename) {
  struct stat st;
  stat(filename, &st);

  // TODO error handling
  FILE *f = fopen(filename, "r");

  ctx->res.body_type = http_response_body_file;
  ctx->res.body = f;
  ctx->res.body_len = st.st_size;
}

void http_loop_res_add_header(http_loop_ctx *ctx, http_header type,
                              const char *value, bool owned) {
  ctx->res.headers[ctx->res.header_count].type = type;
  ctx->res.headers[ctx->res.header_count].value = value;
  ctx->res.headers[ctx->res.header_count].owned = owned;

  ctx->res.header_count++;
}
